summaryrefslogtreecommitdiff
path: root/plugins
diff options
context:
space:
mode:
authorTuowen Zhao <ztuowen@gmail.com>2020-12-16 22:13:45 -0700
committerTuowen Zhao <ztuowen@gmail.com>2020-12-16 22:13:45 -0700
commitfb45741fc1dbd40dd2be72bc35a28c6ee8f3f7a5 (patch)
treedd7746c9910755dfeb5bf28bda68e28b47d5771f /plugins
parent3aaa0bc62ece494dd2b6e47a191de79e562156f9 (diff)
parentb28665aebb4c1b07a57890eb59551bc51d0acf37 (diff)
downloadzsh-fb45741fc1dbd40dd2be72bc35a28c6ee8f3f7a5.tar.gz
zsh-fb45741fc1dbd40dd2be72bc35a28c6ee8f3f7a5.tar.bz2
zsh-fb45741fc1dbd40dd2be72bc35a28c6ee8f3f7a5.zip
Merge remote-tracking branch 'origin/master'
Diffstat (limited to 'plugins')
-rw-r--r--plugins/ansible/ansible.plugin.zsh4
-rw-r--r--plugins/archlinux/archlinux.plugin.zsh18
-rw-r--r--plugins/command-not-found/command-not-found.plugin.zsh24
-rw-r--r--plugins/common-aliases/README.md4
-rw-r--r--plugins/common-aliases/common-aliases.plugin.zsh2
-rw-r--r--plugins/composer/composer.plugin.zsh2
-rw-r--r--plugins/genpass/README.md66
-rwxr-xr-xplugins/genpass/genpass-apple79
-rwxr-xr-xplugins/genpass/genpass-monkey32
-rwxr-xr-xplugins/genpass/genpass-xkcd68
-rw-r--r--plugins/genpass/genpass.plugin.zsh1
-rw-r--r--plugins/git-auto-fetch/README.md43
-rw-r--r--plugins/git-auto-fetch/git-auto-fetch.plugin.zsh81
-rw-r--r--plugins/git-prompt/gitstatus.py4
-rw-r--r--plugins/git/git.plugin.zsh1
-rw-r--r--plugins/grc/README.md37
-rw-r--r--plugins/grc/grc.plugin.zsh44
-rw-r--r--plugins/hanami/README.md63
-rw-r--r--plugins/hanami/hanami.plugin.zsh6
-rw-r--r--plugins/magic-enter/magic-enter.plugin.zsh53
-rw-r--r--plugins/wp-cli/README.md202
-rw-r--r--plugins/wp-cli/wp-cli.plugin.zsh51
22 files changed, 630 insertions, 255 deletions
diff --git a/plugins/ansible/ansible.plugin.zsh b/plugins/ansible/ansible.plugin.zsh
index f68ff23a5..75393b704 100644
--- a/plugins/ansible/ansible.plugin.zsh
+++ b/plugins/ansible/ansible.plugin.zsh
@@ -4,7 +4,7 @@ function ansible-version(){
}
function ansible-role-init(){
- if ! [ -z $1] ; then
+ if ! [ -z $1 ] ; then
echo "Ansible Role : $1 Creating...."
ansible-galaxy init $1
tree $1
@@ -25,4 +25,4 @@ alias ainv='ansible-inventory '
alias adoc='ansible-doc '
alias agal='ansible-galaxy '
alias apull='ansible-pull '
-alias aval='ansible-vault' \ No newline at end of file
+alias aval='ansible-vault'
diff --git a/plugins/archlinux/archlinux.plugin.zsh b/plugins/archlinux/archlinux.plugin.zsh
index 4d39bd86b..c72e06dc2 100644
--- a/plugins/archlinux/archlinux.plugin.zsh
+++ b/plugins/archlinux/archlinux.plugin.zsh
@@ -171,14 +171,13 @@ function paclist() {
}
function pacdisowned() {
- emulate -L zsh
-
+ local tmp db fs
tmp=${TMPDIR-/tmp}/pacman-disowned-$UID-$$
db=$tmp/db
fs=$tmp/fs
mkdir "$tmp"
- trap 'rm -rf "$tmp"' EXIT
+ trap 'rm -rf "$tmp"' EXIT
pacman -Qlq | sort -u > "$db"
@@ -189,15 +188,14 @@ function pacdisowned() {
}
function pacmanallkeys() {
- emulate -L zsh
curl -s https://www.archlinux.org/people/{developers,trustedusers}/ | \
awk -F\" '(/pgp.mit.edu/) { sub(/.*search=0x/,""); print $1}' | \
xargs sudo pacman-key --recv-keys
}
function pacmansignkeys() {
- emulate -L zsh
- for key in $*; do
+ local key
+ for key in $@; do
sudo pacman-key --recv-keys $key
sudo pacman-key --lsign-key $key
printf 'trust\n3\n' | sudo gpg --homedir /etc/pacman.d/gnupg \
@@ -207,13 +205,13 @@ function pacmansignkeys() {
if (( $+commands[xdg-open] )); then
function pacweb() {
- pkg="$1"
- infos="$(LANG=C pacman -Si "$pkg")"
+ local pkg="$1"
+ local infos="$(LANG=C pacman -Si "$pkg")"
if [[ -z "$infos" ]]; then
return
fi
- repo="$(grep -m 1 '^Repo' <<< "$infos" | grep -oP '[^ ]+$')"
- arch="$(grep -m 1 '^Arch' <<< "$infos" | grep -oP '[^ ]+$')"
+ local repo="$(grep -m 1 '^Repo' <<< "$infos" | grep -oP '[^ ]+$')"
+ local arch="$(grep -m 1 '^Arch' <<< "$infos" | grep -oP '[^ ]+$')"
xdg-open "https://www.archlinux.org/packages/$repo/$arch/$pkg/" &>/dev/null
}
fi
diff --git a/plugins/command-not-found/command-not-found.plugin.zsh b/plugins/command-not-found/command-not-found.plugin.zsh
index 81d76e638..aea1e1b4c 100644
--- a/plugins/command-not-found/command-not-found.plugin.zsh
+++ b/plugins/command-not-found/command-not-found.plugin.zsh
@@ -2,7 +2,22 @@
# as seen in https://www.porcheron.info/command-not-found-for-zsh/
# this is installed in Ubuntu
-[[ -e /etc/zsh_command_not_found ]] && source /etc/zsh_command_not_found
+if [ -x /usr/lib/command-not-found -o -x /usr/share/command-not-found/command-not-found ]; then
+ function command_not_found_handler {
+ # check because c-n-f could've been removed in the meantime
+ if [ -x /usr/lib/command-not-found ]; then
+ /usr/lib/command-not-found -- "$1"
+ return $?
+ elif [ -x /usr/share/command-not-found/command-not-found ]; then
+ /usr/share/command-not-found/command-not-found -- "$1"
+ return $?
+ else
+ printf "zsh: command not found: %s\n" "$1" >&2
+ return 127
+ fi
+ return 0
+ }
+fi
# Arch Linux command-not-found support, you must have package pkgfile installed
# https://wiki.archlinux.org/index.php/Pkgfile#.22Command_not_found.22_hook
@@ -10,13 +25,12 @@
# Fedora command-not-found support
if [ -f /usr/libexec/pk-command-not-found ]; then
- command_not_found_handler () {
+ command_not_found_handler() {
runcnf=1
retval=127
[ ! -S /var/run/dbus/system_bus_socket ] && runcnf=0
[ ! -x /usr/libexec/packagekitd ] && runcnf=0
- if [ $runcnf -eq 1 ]
- then
+ if [ $runcnf -eq 1 ]; then
/usr/libexec/pk-command-not-found $@
retval=$?
fi
@@ -32,7 +46,7 @@ fi
# NixOS command-not-found support
if [ -x /run/current-system/sw/bin/command-not-found ]; then
- command_not_found_handler () {
+ command_not_found_handler() {
/run/current-system/sw/bin/command-not-found $@
}
fi
diff --git a/plugins/common-aliases/README.md b/plugins/common-aliases/README.md
index d198a29ac..b6f34cb54 100644
--- a/plugins/common-aliases/README.md
+++ b/plugins/common-aliases/README.md
@@ -40,11 +40,13 @@ plugins=(... common-aliases)
| Alias | Command | Description |
|-------|-----------------------------------------------------|-----------------------------------------|
-| fd | `find . -type d -name` | Find a directory with the given name |
+| fd\* | `find . -type d -name` | Find a directory with the given name |
| ff | `find . -type f -name` | Find a file with the given name |
| grep | `grep --color` | Searches for a query string |
| sgrep | `grep -R -n -H -C 5 --exclude-dir={.git,.svn,CVS}` | Useful for searching within files |
+\* Only if the [`fd`](https://github.com/sharkdp/fd) command isn't installed.
+
### Other Aliases
| Alias | Command | Description |
diff --git a/plugins/common-aliases/common-aliases.plugin.zsh b/plugins/common-aliases/common-aliases.plugin.zsh
index a9d4f1a3d..4e5ff848f 100644
--- a/plugins/common-aliases/common-aliases.plugin.zsh
+++ b/plugins/common-aliases/common-aliases.plugin.zsh
@@ -34,7 +34,7 @@ alias -g P="2>&1| pygmentize -l pytb"
alias dud='du -d 1 -h'
alias duf='du -sh *'
-alias fd='find . -type d -name'
+(( $+commands[fd] )) || alias fd='find . -type d -name'
alias ff='find . -type f -name'
alias h='history'
diff --git a/plugins/composer/composer.plugin.zsh b/plugins/composer/composer.plugin.zsh
index 75b03ffe7..218a13e5f 100644
--- a/plugins/composer/composer.plugin.zsh
+++ b/plugins/composer/composer.plugin.zsh
@@ -51,7 +51,7 @@ alias cget='curl -s https://getcomposer.org/installer | php'
# Add Composer's global binaries to PATH, using Composer if available.
if (( $+commands[composer] )); then
- autoload -Uz _store_cache _retrieve_cache
+ autoload -Uz _store_cache _retrieve_cache _cache_invalid
_retrieve_cache composer
diff --git a/plugins/genpass/README.md b/plugins/genpass/README.md
new file mode 100644
index 000000000..a5ff4a876
--- /dev/null
+++ b/plugins/genpass/README.md
@@ -0,0 +1,66 @@
+# genpass
+
+This plugin provides three unique password generators for ZSH. Each generator
+has at least a 128-bit security margin and generates passwords from the
+cryptographically secure `/dev/urandom`. Each generator can also take an
+optional numeric argument to generate multiple passwords.
+
+To use it from an interactive ZSH, add `genpass` to the plugins array in your
+zshrc file:
+
+ plugins=(... genpass)
+
+You can also invoke password generators directly (they are implemented as
+standalone executable files), which can be handy when you need to generate
+passwords in a script:
+
+ ~/.oh-my-zsh/plugins/genpass/genpass-apple 3
+
+## genpass-apple
+
+Generates a pronounceable pseudoword passphrase of the "cvccvc" consonant/vowel
+syntax, inspired by [Apple's iCloud Keychain password generator][1]. Each
+password has exactly 1 digit placed at the edge of a "word" and exactly 1
+capital letter to satisfy most password security requirements.
+
+ % genpass-apple
+ gelcyv-foqtam-fotqoh-viMleb-lexduv-6ixfuk
+
+ % genpass-apple 3
+ japvyz-qyjti4-kajrod-nubxaW-hukkan-dijcaf
+ vydpig-fucnul-3ukpog-voggom-zygNad-jepgad
+ zocmez-byznis-hegTaj-jecdyq-qiqmiq-5enwom
+
+[1]: https://developer.apple.com/password-rules/
+
+## genpass-monkey
+
+Generates visually unambiguous random meaningless strings using [Crockford's
+base32][2].
+
+ % genpass-monkey
+ xt7gn976e7jj3fstgpy27330x3
+
+ % genpass-monkey 3
+ n1qqwtzgejwgqve9yzf2gxvx4m
+ r2n3f5s6vbqs2yx7xjnmahqewy
+ 296w9y9rts3p5r9yay0raek8e5
+
+[2]: https://www.crockford.com/base32.html
+
+## genpass-xkcd
+
+Generates passphrases from `/usr/share/dict/words` inspired by the [famous (and
+slightly misleading) XKCD comic][3]. Each passphrase is prepended with a digit
+showing the number of words in the passphrase to adhere to password security
+requirements that require digits. Each word is 6 characters or less.
+
+ % genpass-xkcd
+ 9-eaten-Slav-rife-aired-hill-cordon-splits-welsh-napes
+
+ % genpass-xkcd 3
+ 9-worker-Vlad-horde-shrubs-smite-thwart-paw-alters-prawns
+ 9-tutors-stink-rhythm-junk-snappy-hooray-barbs-mewl-clomp
+ 9-vital-escape-Angkor-Huff-wet-Mayra-abbés-putts-guzzle
+
+[3]: https://xkcd.com/936/
diff --git a/plugins/genpass/genpass-apple b/plugins/genpass/genpass-apple
new file mode 100755
index 000000000..963ab6447
--- /dev/null
+++ b/plugins/genpass/genpass-apple
@@ -0,0 +1,79 @@
+#!/usr/bin/env zsh
+#
+# Usage: genpass-apple [NUM]
+#
+# Generate a password made of 6 pseudowords of 6 characters each
+# with the security margin of at least 128 bits.
+#
+# Example password: xudmec-4ambyj-tavric-mumpub-mydVop-bypjyp
+#
+# If given a numerical argument, generate that many passwords.
+
+emulate -L zsh -o no_unset -o warn_create_global -o warn_nested_var
+
+if [[ ARGC -gt 1 || ${1-1} != ${~:-<1-$((16#7FFFFFFF))>} ]]; then
+ print -ru2 -- "usage: $0 [NUM]"
+ return 1
+fi
+
+zmodload zsh/system zsh/mathfunc || return
+
+{
+ local -r vowels=aeiouy
+ local -r consonants=bcdfghjklmnpqrstvwxz
+ local -r digits=0123456789
+
+ # Sets REPLY to a uniformly distributed random number in [1, $1].
+ # Requires: $1 <= 256.
+ function -$0-rand() {
+ local c
+ while true; do
+ sysread -s1 c || return
+ # Avoid bias towards smaller numbers.
+ (( #c < 256 / $1 * $1 )) && break
+ done
+ typeset -g REPLY=$((#c % $1 + 1))
+ }
+
+ local REPLY chars
+
+ repeat ${1-1}; do
+ # Generate 6 pseudowords of the form cvccvc where c and v
+ # denote random consonants and vowels respectively.
+ local words=()
+ repeat 6; do
+ words+=('')
+ repeat 2; do
+ for chars in $consonants $vowels $consonants; do
+ -$0-rand $#chars || return
+ words[-1]+=$chars[REPLY]
+ done
+ done
+ done
+
+ local pwd=${(j:-:)words}
+
+ # Replace either the first or the last character in one of
+ # the words with a random digit.
+ -$0-rand $#digits || return
+ local digit=$digits[REPLY]
+ -$0-rand $((2 * $#words)) || return
+ pwd[REPLY/2*7+2*(REPLY%2)-1]=$digit
+
+ # Convert one lower-case character to upper case.
+ while true; do
+ -$0-rand $#pwd || return
+ [[ $vowels$consonants == *$pwd[REPLY]* ]] && break
+ done
+ # NOTE: We aren't using ${(U)c} here because its results are
+ # locale-dependent. For example, when upper-casing 'i' in Turkish
+ # locale we would get 'İ', a.k.a. latin capital letter i with dot
+ # above. We could set LC_CTYPE=C locally but then we would run afoul
+ # of this zsh bug: https://www.zsh.org/mla/workers/2020/msg00588.html.
+ local c=$pwd[REPLY]
+ printf -v c '%o' $((#c - 32))
+ printf "%s\\$c%s\\n" "$pwd[1,REPLY-1]" "$pwd[REPLY+1,-1]" || return
+ done
+} always {
+ unfunction -m -- "-${(b)0}-*"
+} </dev/urandom
diff --git a/plugins/genpass/genpass-monkey b/plugins/genpass/genpass-monkey
new file mode 100755
index 000000000..94ff5e131
--- /dev/null
+++ b/plugins/genpass/genpass-monkey
@@ -0,0 +1,32 @@
+#!/usr/bin/env zsh
+#
+# Usage: genpass-monkey [NUM]
+#
+# Generate a password made of 26 alphanumeric characters
+# with the security margin of at least 128 bits.
+#
+# Example password: nz5ej2kypkvcw0rn5cvhs6qxtm
+#
+# If given a numerical argument, generate that many passwords.
+
+emulate -L zsh -o no_unset -o warn_create_global -o warn_nested_var
+
+if [[ ARGC -gt 1 || ${1-1} != ${~:-<1-$((16#7FFFFFFF))>} ]]; then
+ print -ru2 -- "usage: $0 [NUM]"
+ return 1
+fi
+
+zmodload zsh/system || return
+
+{
+ local -r chars=abcdefghjkmnpqrstvwxyz0123456789
+ local c
+ repeat ${1-1}; do
+ repeat 26; do
+ sysread -s1 c || return
+ # There is uniform because $#chars divides 256.
+ print -rn -- $chars[#c%$#chars+1]
+ done
+ print
+ done
+} </dev/urandom
diff --git a/plugins/genpass/genpass-xkcd b/plugins/genpass/genpass-xkcd
new file mode 100755
index 000000000..a486ccb40
--- /dev/null
+++ b/plugins/genpass/genpass-xkcd
@@ -0,0 +1,68 @@
+#!/usr/bin/env zsh
+#
+# Usage: genpass-xkcd [NUM]
+#
+# Generate a password made of words from /usr/share/dict/words
+# with the security margin of at least 128 bits.
+#
+# Example password: 9-mien-flood-Patti-buxom-dozes-ickier-pay-ailed-Foster
+#
+# If given a numerical argument, generate that many passwords.
+#
+# The name of this utility is a reference to https://xkcd.com/936/.
+
+emulate -L zsh -o no_unset -o warn_create_global -o warn_nested_var -o extended_glob
+
+if [[ ARGC -gt 1 || ${1-1} != ${~:-<1-$((16#7FFFFFFF))>} ]]; then
+ print -ru2 -- "usage: $0 [NUM]"
+ return 1
+fi
+
+zmodload zsh/system zsh/mathfunc || return
+
+local -r dict=/usr/share/dict/words
+
+if [[ ! -e $dict ]]; then
+ print -ru2 -- "$0: file not found: $dict"
+ return 1
+fi
+
+# Read all dictionary words and leave only those made of 1-6 characters.
+local -a words
+words=(${(M)${(f)"$(<$dict)"}:#[a-zA-Z](#c1,6)}) || return
+
+if (( $#words < 2 )); then
+ print -ru2 -- "$0: not enough suitable words in $dict"
+ return 1
+fi
+
+if (( $#words > 16#7FFFFFFF )); then
+ print -ru2 -- "$0: too many words in $dict"
+ return 1
+fi
+
+# Figure out how many words we need for 128 bits of security margin.
+# Each word adds log2($#words) bits.
+local -i n=$((ceil(128. / log2($#words))))
+
+{
+ local c
+ repeat ${1-1}; do
+ print -rn -- $n
+ repeat $n; do
+ while true; do
+ # Generate a random number in [0, 2**31).
+ local -i rnd=0
+ repeat 4; do
+ sysread -s1 c || return
+ (( rnd = (~(1 << 23) & rnd) << 8 | #c ))
+ done
+ # Avoid bias towards words in the beginning of the list.
+ (( rnd < 16#7FFFFFFF / $#words * $#words )) || continue
+ print -rn -- -$words[rnd%$#words+1]
+ break
+ done
+ done
+ print
+ done
+} </dev/urandom
diff --git a/plugins/genpass/genpass.plugin.zsh b/plugins/genpass/genpass.plugin.zsh
new file mode 100644
index 000000000..a0ea841cd
--- /dev/null
+++ b/plugins/genpass/genpass.plugin.zsh
@@ -0,0 +1 @@
+autoload -Uz genpass-apple genpass-monkey genpass-xkcd
diff --git a/plugins/git-auto-fetch/README.md b/plugins/git-auto-fetch/README.md
index 35f3c2f71..e96ab42a3 100644
--- a/plugins/git-auto-fetch/README.md
+++ b/plugins/git-auto-fetch/README.md
@@ -1,26 +1,29 @@
# Git auto-fetch
-Automatically fetches all changes from all remotes while you are working in git-initialized directory.
+Automatically fetches all changes from all remotes while you are working in a git-initialized directory.
-#### Usage
-
-Add `git-auto-fetch` to the plugins array in your zshrc file:
+To use it, add `git-auto-fetch` to the plugins array in your zshrc file:
```shell
plugins=(... git-auto-fetch)
```
-Every time you launch a command in your shell all remotes will be fetched in background.
-By default autofetch will be triggered only if last fetch was done at least 60 seconds ago.
-You can change fetch interval in your .zshrc:
-```
-GIT_AUTO_FETCH_INTERVAL=1200 #in seconds
+## Usage
+
+Every time the command prompt is shown all remotes will be fetched in the background. By default,
+`git-auto-fetch` will be triggered only if the last auto-fetch was done at least 60 seconds ago.
+You can change the fetch interval in your .zshrc:
+
+```sh
+GIT_AUTO_FETCH_INTERVAL=1200 # in seconds
```
-Log of `git fetch --all` will be saved into `.git/FETCH_LOG`
+A log of `git fetch --all` will be saved in `.git/FETCH_LOG`.
+
+## Toggle auto-fetch per folder
-#### Toggle auto fetch per folder
-If you are using mobile connection or for any other reason you can disable git-auto-fetch for any folder:
+If you are using a mobile connection or for any other reason you can disable git-auto-fetch
+for any folder:
```shell
$ cd to/your/project
@@ -29,3 +32,19 @@ disabled
$ git-auto-fetch
enabled
```
+
+## Caveats
+
+Automatically fetching all changes defeats the purpose of `git push --force-with-lease`,
+and makes it behave like `git push --force` in some cases. For example:
+
+Consider that you made some changes and possibly rebased some stuff, which means you'll
+need to use `--force-with-lease` to overwrite the remote history of a branch. Between the
+time when you make the changes (maybe do a `git log`) and the time when you `git push`,
+it's possible that someone else updates the branch you're working on.
+
+If `git-auto-fetch` triggers then, you'll have fetched the remote changes without knowing
+it, and even though you're running the push with `--force-with-lease`, git will overwrite
+the recent changes because you already have them in your local repository. The
+[`git push --force-with-lease` docs](https://git-scm.com/docs/git-push) talk about possible
+solutions to this problem.
diff --git a/plugins/git-auto-fetch/git-auto-fetch.plugin.zsh b/plugins/git-auto-fetch/git-auto-fetch.plugin.zsh
index 5c42c21a7..0da84f2f5 100644
--- a/plugins/git-auto-fetch/git-auto-fetch.plugin.zsh
+++ b/plugins/git-auto-fetch/git-auto-fetch.plugin.zsh
@@ -1,36 +1,61 @@
-GIT_AUTO_FETCH_INTERVAL=${GIT_AUTO_FETCH_INTERVAL:=60}
+# Default auto-fetch interval: 60 seconds
+: ${GIT_AUTO_FETCH_INTERVAL:=60}
+
+# Necessary for the git-fetch-all function
+zmodload zsh/datetime zsh/stat
function git-fetch-all {
- (`command git rev-parse --is-inside-work-tree 2>/dev/null` &&
- dir=`command git rev-parse --git-dir` &&
- [[ ! -f $dir/NO_AUTO_FETCH ]] &&
- (( `date +%s` - `date -r $dir/FETCH_LOG +%s 2>/dev/null || echo 0` > $GIT_AUTO_FETCH_INTERVAL )) &&
- GIT_SSH_COMMAND="command ssh -o BatchMode=yes" \
- command git fetch --all 2>/dev/null &>! $dir/FETCH_LOG &)
+ (
+ # Get git root directory
+ if ! gitdir="$(command git rev-parse --git-dir 2>/dev/null)"; then
+ return 0
+ fi
+
+ # Do nothing if auto-fetch disabled
+ if [[ -z "$gitdir" || -f "$gitdir/NO_AUTO_FETCH" ]]; then
+ return 0
+ fi
+
+ # Get time (seconds) when auto-fetch was last run
+ lastrun="$(zstat +mtime "$gitdir/FETCH_LOG" 2>/dev/null || echo 0)"
+ # Do nothing if not enough time has passed since last auto-fetch
+ if (( EPOCHSECONDS - lastrun < $GIT_AUTO_FETCH_INTERVAL )); then
+ return 0
+ fi
+
+ # Fetch all remotes (avoid ssh passphrase prompt)
+ GIT_SSH_COMMAND="command ssh -o BatchMode=yes" \
+ command git fetch --all 2>/dev/null &>! "$gitdir/FETCH_LOG"
+ ) &|
}
function git-auto-fetch {
- `command git rev-parse --is-inside-work-tree 2>/dev/null` || return
- guard="`command git rev-parse --git-dir`/NO_AUTO_FETCH"
+ # Do nothing if not in a git repository
+ command git rev-parse --is-inside-work-tree &>/dev/null || return 0
- (rm $guard 2>/dev/null &&
- echo "${fg_bold[green]}enabled${reset_color}") ||
- (touch $guard &&
- echo "${fg_bold[red]}disabled${reset_color}")
+ # Remove or create guard file depending on its existence
+ local guard="$(command git rev-parse --git-dir)/NO_AUTO_FETCH"
+ if [[ -f "$guard" ]]; then
+ command rm "$guard" && echo "${fg_bold[green]}enabled${reset_color}"
+ else
+ command touch "$guard" && echo "${fg_bold[red]}disabled${reset_color}"
+ fi
}
-# Override zle-line-init if it exists
-if (( $+functions[zle-line-init] )); then
- eval "override-git-auto-fetch-$(declare -f zle-line-init)"
-
- function zle-line-init () {
- git-fetch-all
- override-git-auto-fetch-zle-line-init
- }
-else
- function zle-line-init () {
- git-fetch-all
- }
-fi
-
-zle -N zle-line-init
+# zle-line-init widget (don't redefine if already defined)
+(( ! ${+functions[_git-auto-fetch_zle-line-init]} )) || return 0
+
+case "$widgets[zle-line-init]" in
+ # Simply define the function if zle-line-init doesn't yet exist
+ builtin|"") function _git-auto-fetch_zle-line-init() {
+ git-fetch-all
+ } ;;
+ # Override the current zle-line-init widget, calling the old one
+ user:*) zle -N _git-auto-fetch_orig_zle-line-init "${widgets[zle-line-init]#user:}"
+ function _git-auto-fetch_zle-line-init() {
+ git-fetch-all
+ zle _git-auto-fetch_orig_zle-line-init -- "$@"
+ } ;;
+esac
+
+zle -N zle-line-init _git-auto-fetch_zle-line-init
diff --git a/plugins/git-prompt/gitstatus.py b/plugins/git-prompt/gitstatus.py
index 300365d71..bf3173614 100644
--- a/plugins/git-prompt/gitstatus.py
+++ b/plugins/git-prompt/gitstatus.py
@@ -11,11 +11,11 @@ def get_tagname_or_hash():
"""return tagname if exists else hash"""
# get hash
hash_cmd = ['git', 'rev-parse', '--short', 'HEAD']
- hash_ = check_output(hash_cmd).strip()
+ hash_ = check_output(hash_cmd).decode('utf-8').strip()
# get tagname
tags_cmd = ['git', 'for-each-ref', '--points-at=HEAD', '--count=2', '--sort=-version:refname', '--format=%(refname:short)', 'refs/tags']
- tags = check_output(tags_cmd).split()
+ tags = check_output(tags_cmd).decode('utf-8').split()
if tags:
return tags[0] + ('+' if len(tags) > 1 else '')
diff --git a/plugins/git/git.plugin.zsh b/plugins/git/git.plugin.zsh
index bf2619976..e32136f15 100644
--- a/plugins/git/git.plugin.zsh
+++ b/plugins/git/git.plugin.zsh
@@ -31,6 +31,7 @@ function work_in_progress() {
# Check if main exists and use instead of master
function git_main_branch() {
+ command git rev-parse --git-dir &>/dev/null || return
local branch
for branch in main trunk; do
if command git show-ref -q --verify refs/heads/$branch; then
diff --git a/plugins/grc/README.md b/plugins/grc/README.md
new file mode 100644
index 000000000..dfda41466
--- /dev/null
+++ b/plugins/grc/README.md
@@ -0,0 +1,37 @@
+# Generic Colouriser plugin
+
+This plugin adds wrappers for commands supported by [Generic Colouriser](https://github.com/garabik/grc):
+
+To use it, add `grc` to the plugins array in your zshrc file:
+
+```zsh
+plugins=(... grc)
+```
+
+## Commands
+
+The following commands are wrapped by `grc` so that their output is automatically colored:
+
+- `cc`
+- `configure`
+- `cvs`
+- `df`
+- `diff`
+- `dig`
+- `gcc`
+- `gmake`
+- `ifconfig`
+- `iwconfig`
+- `last`
+- `ldap`
+- `make`
+- `mount`
+- `mtr`
+- `netstat`
+- `ping`
+- `ping6`
+- `ps`
+- `traceroute`
+- `traceroute6`
+- `wdiff`
+- `whois`
diff --git a/plugins/grc/grc.plugin.zsh b/plugins/grc/grc.plugin.zsh
new file mode 100644
index 000000000..6a52ec568
--- /dev/null
+++ b/plugins/grc/grc.plugin.zsh
@@ -0,0 +1,44 @@
+# Adapted from: https://github.com/garabik/grc/blob/master/grc.zsh
+
+if [[ "$TERM" = dumb ]] || (( ! $+commands[grc] )); then
+ return
+fi
+
+# Supported commands
+cmds=(
+ cc
+ configure
+ cvs
+ df
+ diff
+ dig
+ gcc
+ gmake
+ ifconfig
+ iwconfig
+ last
+ ldap
+ make
+ mount
+ mtr
+ netstat
+ ping
+ ping6
+ ps
+ traceroute
+ traceroute6
+ wdiff
+ whois
+)
+
+# Set alias for supported commands
+for cmd in $cmds; do
+ if (( $+commands[$cmd] )); then
+ eval "function $cmd {
+ grc --colour=auto \"${commands[$cmd]}\" \"\$@\"
+ }"
+ fi
+done
+
+# Clean up variables
+unset cmds cmd
diff --git a/plugins/hanami/README.md b/plugins/hanami/README.md
index 3ac8defbb..c9e09f4f2 100644
--- a/plugins/hanami/README.md
+++ b/plugins/hanami/README.md
@@ -1,32 +1,45 @@
-# Hanami Plugin #
-This plugin adds convenient ways to work with [Hanami](https://hanamirb.org/) via console.
+# Hanami Plugin
+
+This plugin adds convenient aliases to work with [Hanami](https://hanamirb.org/) via console.
It's inspired by Rails plugin, so if you've used it, you'll feel like home.
-## Usage ##
+To use it, add `hanami` to the plugins array in your zshrc file:
+
+```zsh
+plugins=(... hanami)
+```
+
+## Usage
For example, type `hc` into your console when you're within Hanami project directory to run
the application console. Have a look at available shortcuts below. You can read more about
these commands [on the official website](https://hanamirb.org/guides/command-line/applications/).
-## Aliases ##
-
-| Alias | Command | Description |
-|-------|---------------------------|---------------------------------------------------------|
-| HED | HANAMI_ENV=development | Set environment variable HANAMI_ENV to development |
-| HEP | HANAMI_ENV=production | Set environment variable HANAMI_ENV to production |
-| HET | HANAMI_ENV=test | Set environment variable HANAMI_ENV to test |
-| hc | hanami console | Run application console |
-| hd | hanami destroy | Remove specified hanami resource |
-| hg | hanami generate | Create specified hanami resource |
-| hgm | hanami generate migration | Create migration file |
-| hs | hanami server | Launch server with hanami application |
-| hsp | hanami server -p | Launch server with specified port |
-| hr | hanami routes | List application routes |
-| hdc | hanami db create | Create application database |
-| hdd | hanami db drop | Delete application database |
-| hdp | hanami db prepare | Prepare database for the current environment |
-| hda | hanami db apply | Recreates a fresh schema after migrations (destructive) |
-| hdv | hanami db version | Print current database version |
-| hdrs | hdd && hdp | Drop and recreate application database |
-| hdtp | HET hdp | Actualize test environment database |
-| hrg | hr &#124; grep | Grep hanami routes with specified pattern |
+## Aliases
+
+| Alias | Command | Description |
+|-------|-----------------------------|---------------------------------------------------------|
+| HED\* | `HANAMI_ENV=development` | Set environment variable HANAMI_ENV to development |
+| HEP\* | `HANAMI_ENV=production` | Set environment variable HANAMI_ENV to production |
+| HET\* | `HANAMI_ENV=test` | Set environment variable HANAMI_ENV to test |
+| hc | `hanami console` | Run application console |
+| hd | `hanami destroy` | Remove specified hanami resource |
+| hg | `hanami generate` | Create specified hanami resource |
+| hgm | `hanami generate migration` | Create migration file |
+| hs | `hanami server` | Launch server with hanami application |
+| hsp | `hanami server -p` | Launch server with specified port |
+| hr | `hanami routes` | List application routes |
+| hdc | `hanami db create` | Create application database |
+| hdd | `hanami db drop` | Delete application database |
+| hdp | `hanami db prepare` | Prepare database for the current environment |
+| hda | `hanami db apply` | Recreates a fresh schema after migrations (destructive) |
+| hdv | `hanami db version` | Print current database version |
+| hdrs | `hdd && hdp` | Drop and recreate application database |
+| hdtp | `HET hdp` | Actualize test environment database |
+| hrg | `hr | grep` | Grep hanami routes with specified pattern |
+
+\* You should use these at the beginning of a command, for example:
+
+```console
+$ HED hdd # equivalent to 'HANAMI_ENV=development hanami db drop'
+```
diff --git a/plugins/hanami/hanami.plugin.zsh b/plugins/hanami/hanami.plugin.zsh
index 349c42cae..42143b428 100644
--- a/plugins/hanami/hanami.plugin.zsh
+++ b/plugins/hanami/hanami.plugin.zsh
@@ -1,6 +1,6 @@
-alias -g HED='HANAMI_ENV=development'
-alias -g HEP='HANAMI_ENV=production'
-alias -g HET='HANAMI_ENV=test'
+alias HED='HANAMI_ENV=development '
+alias HEP='HANAMI_ENV=production '
+alias HET='HANAMI_ENV=test '
alias hc='hanami console'
alias hd='hanami destroy'
diff --git a/plugins/magic-enter/magic-enter.plugin.zsh b/plugins/magic-enter/magic-enter.plugin.zsh
index 2d4d578b6..55b893535 100644
--- a/plugins/magic-enter/magic-enter.plugin.zsh
+++ b/plugins/magic-enter/magic-enter.plugin.zsh
@@ -1,27 +1,38 @@
-# Bind quick stuff to enter!
-#
-# Pressing enter in a git directory runs `git status`
-# in other directories `ls`
-magic-enter () {
- # If commands are not already set, use the defaults
- [ -z "$MAGIC_ENTER_GIT_COMMAND" ] && MAGIC_ENTER_GIT_COMMAND="git status -u ."
- [ -z "$MAGIC_ENTER_OTHER_COMMAND" ] && MAGIC_ENTER_OTHER_COMMAND="ls -lh ."
+# Default commands
+: ${MAGIC_ENTER_GIT_COMMAND:="git status -u ."} # run when in a git repository
+: ${MAGIC_ENTER_OTHER_COMMAND:="ls -lh ."} # run anywhere else
- if [[ -z $BUFFER ]]; then
- echo ""
- if git rev-parse --is-inside-work-tree &>/dev/null; then
- eval "$MAGIC_ENTER_GIT_COMMAND"
- else
- eval "$MAGIC_ENTER_OTHER_COMMAND"
- fi
- zle redisplay
+magic-enter() {
+ # Only run MAGIC_ENTER commands when in PS1 and command line is empty
+ # http://zsh.sourceforge.net/Doc/Release/Zsh-Line-Editor.html#User_002dDefined-Widgets
+ if [[ -n "$BUFFER" || "$CONTEXT" != start ]]; then
+ return
+ fi
+
+ if command git rev-parse --is-inside-work-tree &>/dev/null; then
+ BUFFER="$MAGIC_ENTER_GIT_COMMAND"
else
- zle accept-line
+ BUFFER="$MAGIC_ENTER_OTHER_COMMAND"
fi
}
-zle -N magic-enter
+# Wrapper for the accept-line zle widget (run when pressing Enter)
+
+# If the wrapper already exists don't redefine it
+(( ! ${+functions[_magic-enter_accept-line]} )) || return 0
+
+case "$widgets[accept-line]" in
+ # Override the current accept-line widget, calling the old one
+ user:*) zle -N _magic-enter_orig_accept-line "${widgets[accept-line]#user:}"
+ function _magic-enter_accept-line() {
+ magic-enter
+ zle _magic-enter_orig_accept-line -- "$@"
+ } ;;
+ # If no user widget defined, call the original accept-line widget
+ builtin) function _magic-enter_accept-line() {
+ magic-enter
+ zle .accept-line
+ } ;;
+esac
-bindkey -M emacs "^M" magic-enter
-bindkey -M vicmd "^M" magic-enter
-bindkey -M viins "^M" magic-enter
+zle -N accept-line _magic-enter_accept-line
diff --git a/plugins/wp-cli/README.md b/plugins/wp-cli/README.md
index 43c41eb53..c4993ab4c 100644
--- a/plugins/wp-cli/README.md
+++ b/plugins/wp-cli/README.md
@@ -1,107 +1,109 @@
# WP-CLI
-**Maintainer:** [joshmedeski](https://github.com/joshmedeski)
-
-WordPress Command Line Interface (https://wp-cli.org/)
-
-WP-CLI is a set of command-line tools for managing WordPress installations. You can update plugins, set up multisite installs and much more, without using a web browser.
-
-This plugin adds [tab completion](https://wp-cli.org/#tab-completions) for `wp-cli` as well as several aliases.
-
-## List of Aliases
-
-### Core
-- wpcc='wp core config'
-- wpcd='wp core download'
-- wpci='wp core install'
-- wpcii='wp core is-installed'
-- wpcmc='wp core multisite-convert'
-- wpcmi='wp core multisite-install'
-- wpcu='wp core update'
-- wpcudb='wp core update-db'
-- wpcvc='wp core verify-checksums'
-
-### Cron
-- wpcre='wp cron event'
-- wpcrs='wp cron schedule'
-- wpcrt='wp cron test'
+The [WordPress CLI](https://wp-cli.org/) is a command-line tool for managing WordPress installations. You can update plugins, set up multisite installs and much more, without using a web browser.
-### Menu
-- wpmc='wp menu create'
-- wpmd='wp menu delete'
-- wpmi='wp menu item'
-- wpml='wp menu list'
-- wpmlo='wp menu location'
+This plugin adds [tab completion](https://wp-cli.org/#tab-completions) for `wp-cli` as well as several aliases for commonly used commands.
-### Plugin
-- wppa='activate'
-- wppda='deactivate'
-- wppd='delete'
-- wppg='get'
-- wppi='install'
-- wppis='is-installed'
-- wppl='list'
-- wppp='path'
-- wpps='search'
-- wppst='status'
-- wppt='toggle'
-- wppun='uninstall'
-- wppu='update'
+To use it, add `wp-cli` to the plugins array in your zshrc file:
-### Post
-- wppoc='wp post create'
-- wppod='wp post delete'
-- wppoe='wp post edit'
-- wppogen='wp post generate'
-- wppog='wp post get'
-- wppol='wp post list'
-- wppom='wp post meta'
-- wppou='wp post update'
-- wppourl='wp post url'
+```zsh
+plugins=(... wp-cli)
+```
-### Sidebar
-- wpsbl='wp sidebar list'
-
-### Theme
-- wpta='wp theme activate'
-- wptd='wp theme delete'
-- wptdis='wp theme disable'
-- wpte='wp theme enable'
-- wptg='wp theme get'
-- wpti='wp theme install'
-- wptis='wp theme is-installed'
-- wptl='wp theme list'
-- wptm='wp theme mod'
-- wptp='wp theme path'
-- wpts='wp theme search'
-- wptst='wp theme status'
-- wptu='wp theme update'
-
-### User
-- wpuac='wp user add-cap'
-- wpuar='wp user add-role'
-- wpuc='wp user create'
-- wpud='wp user delete'
-- wpugen='wp user generate'
-- wpug='wp user get'
-- wpui='wp user import-csv'
-- wpul='wp user list'
-- wpulc='wp user list-caps'
-- wpum='wp user meta'
-- wpurc='wp user remove-cap'
-- wpurr='wp user remove-role'
-- wpusr='wp user set-role'
-- wpuu='wp user update'
-
-### Widget
-- wpwa='wp widget add'
-- wpwda='wp widget deactivate'
-- wpwd='wp widget delete'
-- wpwl='wp widget list'
-- wpwm='wp widget move'
-- wpwu='wp widget update'
-
-The entire list of wp-cli commands can be found here: https://wp-cli.org/commands/
-
-I only included the commands that are most used. Please feel free to contribute to this project if you want more commands.
+**Maintainer:** [joshmedeski](https://github.com/joshmedeski)
+## Aliases
+
+The entire list of `wp-cli` commands can be found here: https://developer.wordpress.org/cli/commands/
+
+| Alias | Command |
+|-----------|-----------------------------|
+| **Core** |
+| `wpcc` | `wp core config` |
+| `wpcd` | `wp core download` |
+| `wpci` | `wp core install` |
+| `wpcii` | `wp core is-installed` |
+| `wpcmc` | `wp core multisite-convert` |
+| `wpcmi` | `wp core multisite-install` |
+| `wpcu` | `wp core update` |
+| `wpcudb` | `wp core update-db` |
+| `wpcvc` | `wp core verify-checksums` |
+| **Cron** |
+| `wpcre` | `wp cron event` |
+| `wpcrs` | `wp cron schedule` |
+| `wpcrt` | `wp cron test` |
+| **Database** |
+| `wpdbe` | `wp db export` |
+| `wpdbi` | `wp db import` |
+| `wpdbcr` | `wp db create` |
+| `wpdbs` | `wp db search` |
+| `wpdbch` | `wp db check` |
+| `wpdbr` | `wp db repair` |
+| **Menu** |
+| `wpmc` | `wp menu create` |
+| `wpmd` | `wp menu delete` |
+| `wpmi` | `wp menu item` |
+| `wpml` | `wp menu list` |
+| `wpmlo` | `wp menu location` |
+| **Plugin** |
+| `wppa` | `wp plugin activate` |
+| `wppda` | `wp plugin deactivate` |
+| `wppd` | `wp plugin delete` |
+| `wppg` | `wp plugin get` |
+| `wppi` | `wp plugin install` |
+| `wppis` | `wp plugin is-installed` |
+| `wppl` | `wp plugin list` |
+| `wppp` | `wp plugin path` |
+| `wpps` | `wp plugin search` |
+| `wppst` | `wp plugin status` |
+| `wppt` | `wp plugin toggle` |
+| `wppun` | `wp plugin uninstall` |
+| `wppu` | `wp plugin update` |
+| **Post** |
+| `wppoc` | `wp post create` |
+| `wppod` | `wp post delete` |
+| `wppoe` | `wp post edit` |
+| `wppogen` | `wp post generate` |
+| `wppog` | `wp post get` |
+| `wppol` | `wp post list` |
+| `wppom` | `wp post meta` |
+| `wppou` | `wp post update` |
+| `wppourl` | `wp post url` |
+| **Sidebar** |
+| `wpsbl` | `wp sidebar list` |
+| **Theme** |
+| `wpta` | `wp theme activate` |
+| `wptd` | `wp theme delete` |
+| `wptdis` | `wp theme disable` |
+| `wpte` | `wp theme enable` |
+| `wptg` | `wp theme get` |
+| `wpti` | `wp theme install` |
+| `wptis` | `wp theme is-installed` |
+| `wptl` | `wp theme list` |
+| `wptm` | `wp theme mod` |
+| `wptp` | `wp theme path` |
+| `wpts` | `wp theme search` |
+| `wptst` | `wp theme status` |
+| `wptu` | `wp theme update` |
+| **User** |
+| `wpuac` | `wp user add-cap` |
+| `wpuar` | `wp user add-role` |
+| `wpuc` | `wp user create` |
+| `wpud` | `wp user delete` |
+| `wpugen` | `wp user generate` |
+| `wpug` | `wp user get` |
+| `wpui` | `wp user import-csv` |
+| `wpul` | `wp user list` |
+| `wpulc` | `wp user list-caps` |
+| `wpum` | `wp user meta` |
+| `wpurc` | `wp user remove-cap` |
+| `wpurr` | `wp user remove-role` |
+| `wpusr` | `wp user set-role` |
+| `wpuu` | `wp user update` |
+| **Widget** |
+| `wpwa` | `wp widget add` |
+| `wpwda` | `wp widget deactivate` |
+| `wpwd` | `wp widget delete` |
+| `wpwl` | `wp widget list` |
+| `wpwm` | `wp widget move` |
+| `wpwu` | `wp widget update` |
diff --git a/plugins/wp-cli/wp-cli.plugin.zsh b/plugins/wp-cli/wp-cli.plugin.zsh
index 97bed406e..09bdf3260 100644
--- a/plugins/wp-cli/wp-cli.plugin.zsh
+++ b/plugins/wp-cli/wp-cli.plugin.zsh
@@ -2,14 +2,6 @@
# A command line interface for WordPress
# https://wp-cli.org/
-# Cache
-
-# Cap
-
-# CLI
-
-# Comment
-
# Core
alias wpcc='wp core config'
alias wpcd='wp core download'
@@ -27,18 +19,12 @@ alias wpcrs='wp cron schedule'
alias wpcrt='wp cron test'
# Db
-
-# Eval
-
-# Eval-File
-
-# Export
-
-# Help
-
-# Import
-
-# Media
+alias wpdbe='wp db export'
+alias wpdbi='wp db import'
+alias wpdbcr='wp db create'
+alias wpdbs='wp db search'
+alias wpdbch='wp db check'
+alias wpdbr='wp db repair'
# Menu
alias wpmc='wp menu create'
@@ -47,10 +33,6 @@ alias wpmi='wp menu item'
alias wpml='wp menu list'
alias wpmlo='wp menu location'
-# Network
-
-# Option
-
# Plugin
alias wppa='wp plugin activate'
alias wppda='wp plugin deactivate'
@@ -77,25 +59,9 @@ alias wppom='wp post meta'
alias wppou='wp post update'
alias wppourl='wp post url'
-# Rewrite
-
-# Role
-
-# Scaffold
-
-# Search-Replace
-
-# Shell
-
# Sidebar
alias wpsbl='wp sidebar list'
-# Site
-
-# Super-Admin
-
-# Term
-
# Theme
alias wpta='wp theme activate'
alias wptd='wp theme delete'
@@ -111,8 +77,6 @@ alias wpts='wp theme search'
alias wptst='wp theme status'
alias wptu='wp theme update'
-# Transient
-
# User
alias wpuac='wp user add-cap'
alias wpuar='wp user add-role'
@@ -138,9 +102,8 @@ alias wpwm='wp widget move'
alias wpwu='wp widget update'
+# Completion for wp
autoload -U +X bashcompinit && bashcompinit
-# bash completion for the `wp` command
-
_wp_complete() {
local cur=${COMP_WORDS[COMP_CWORD]}